#!/usr/bin/env python

import os, sys, base64

VERSIONEER_b64 = """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"""
newver = "0.18"


def main():
    if len(sys.argv) < 2:
        print("Usage: versioneer install")
        sys.exit(1)

    command = sys.argv[1]
    if command in ("version", "--version"):
        print("versioneer (installer) %s" % newver)
        sys.exit(0)

    if command != "install":
        print("Usage: versioneer install")
        sys.exit(1)

    v = base64.b64decode(VERSIONEER_b64.encode('ASCII'))
    if os.path.exists("versioneer.py"):
        for line in open("versioneer.py").readlines()[:5]:
            if line.startswith("# Version: "):
                oldver = line[len("# Version: "):].strip()
                if oldver != newver:
                    print("replacing old versioneer.py (%s)" % oldver)
                break
        else:
            print("overwriting existing versioneer.py")
    with open("versioneer.py", "wb") as f:
        f.write(v)
    print("versioneer.py (%s) installed into local tree" % newver)
    print("Now running 'versioneer.py setup' to install the generated files..")
    if " " in sys.executable:
        import subprocess  # Do not import unless absolutely necessary to avoid compatibility issues
        subprocess.call([sys.executable, "versioneer.py", "setup"])
    else:
        os.execl(sys.executable, sys.executable, "versioneer.py", "setup")

if __name__ == '__main__':
    main()
